// Implementierung von ShellSort

class ShellSort {	
	static int cmp_cnt = 0;
	static int xch_cnt = 0;
    	static boolean less(ITEM v, ITEM w) {
		cmp_cnt++;
		return v.less(w);
	}
    	static void exch(ITEM[] a, int i, int j) {
		ITEM t = a[i];
		a[i] = a[j];
		a[j] = t;
		xch_cnt++;
	}
    	static void compExch(ITEM[] a, int i, int j) {
		cmp_cnt++;
		if (less(a[j], a[i]))
			exch (a, i, j);
	}

// Passen InsertionSort so an, dass h-Sortieren der Datei erfolgt
// --> müssen dazu jede "1" durch "h" als Sprungweite ersetzen
//
// Fügen äußere Schleife hinzu, um die Abstände ("h") zu ändern
// Verwenden Abstandsfolge 1 4 13 40 121 364 1093 3280 9841 ...

	static void sort(ITEM[] a, int l, int r) {
		shell(a, l, r);
	}
	static void shell(ITEM[] a, int l, int r) {
		int h;
		// grösstes h in Abstandsfolge berechnen
    		for (h = 1; h <= (r-l)/9; h = 3*h+1);

		// Iterationsschritt ermittelt nächstkleineres 
		// Element aus Abstandsfolge
    		for ( ; h > 0; h /= 3)
      			for (int i = l+h; i <= r; i++) {
				int j = i;
				ITEM v = a[i];
          			while (j >= l+h && less(v, a[j-h])) {
					xch_cnt++;
					a[j] = a[j-h];
					j -= h;
				}
        			a[j] = v;
      			}
  	}
    	public static void main(String[] args) {
		int N = 0;

		try {
			N = Integer.parseInt(args[0]);
		} catch (Exception e) {
			Out.println("usage java ShellSort #elem");
			System.exit(1);
		}
        	myItem a[] = new myItem[N];

        	for (int i = 0; i < N; i++) {
			a[i] = new myItem();
			a[i].rand();
		}
        	sort(a, 0, N-1);
        	if (N < 100)
          		for (int i = 0; i < N; i++) 
            			Out.println(a[i] + "");
        	Out.println("Compares used: " + cmp_cnt);
        	Out.println("Exchanges used: " + xch_cnt);
      }
}
